OUTPUT_FORMAT("elf32-h8300")
OUTPUT_ARCH(h8300:h8300s)
ENTRY(_start)
MEMORY {
	sysvec(r)	: o = 0x0e0000, l = 0x000200	/* virtual vector table */
	rom(rx)		: o = 0x0e0200, l = 0x00fe00	/* user module area RO and X (extRAM) */
	ram(rw)		: o = 0xffe080, l = 0x000f80	/* user module area RW (on intRAM) */
/*	ram(rw)		: o = 0x0e0f00, l = 0x000080	/* user module area RW (on extRAM) */
	usrsp(rw)	: o = 0xfff000, l = 0x000000	/* end of user module area */
/*	usrsp(rw)	: o = 0x0e1000, l = 0x000000	/* end of user module area */
}
SECTIONS {
INCLUDE ../H8S_kernel_2144.xc
	/* ¹ԥץΰ褬֤륻 */
	.text : ALIGN(1) {
		FILL(0xff);
		__text_start = . ;
		*(.text.exception);
		*(.text);
		__text_end = . ;
		. = ALIGN(2) ;
	} > rom
	/* 񤭴ԲĤΥǡΰ褬֤륻 */
	.rodata : ALIGN(0) {
		FILL(0xff)
		*(.rodata .rodata.*)
		___rodata_end = . ;
	} > rom
	/* C++Υ󥹥ȥ饯/ǥȥ饯֤륻 */
	.tors : AT (ADDR(.rodata)+SIZEOF(.rodata)) ALIGN(0) {
		FILL(0x00)
		___ctors = . ;
		*(.ctors)
		___ctors_end = . ;
		___dtors = . ;
		*(.dtors)
		___dtors_end = . ;
	} > ram
	/* ͤäǡΰ褬֤륻 */
	/*   ATλˤꥤ᡼Τϡ.torΰľ֤ */
	/*   뤬ΰλȥɥ쥹¢ram򼨤褦ˤʤäƤ */
	.data : AT (ADDR(.rodata)+SIZEOF(.rodata)+SIZEOF(.tors)) ALIGN(0) {
		FILL(0xff)
		_data = . ;
		*(.data .data.*)
		_edata = . ;
	} > ram
	/* ͤʤǡΰ褬֤륻 */
	.bss : ALIGN(0) {
		FILL(0x00)
		_bss_start = . ;
		*(.bss)
		*(COMMON)
		_end = . ;
	}  > ram
	/* åΰ褬֤륻 */
	.usr_stack : ALIGN(1) { /* user stack */
		FILL(0xff);
		_usr_stack = . ;
		_stack = . ;
	} > usrsp
	/* ٥ơ֥ΰ褬֤륻 */
	.sysvec : ALIGN(2) {
		FILL(0xff);
		_SYS_vector = ABSOLUTE(.) ;
	/*  0 */	LONG(DEFINED(_start)?ABSOLUTE(_start):ABSOLUTE(0xffffffff))	/*  0 Reset vector */
	/*  1 */	LONG(ABSOLUTE(0xffffffff))	/* Reserved */
	/*  2 */	LONG(ABSOLUTE(0xffffffff))
	/*  3 */	LONG(ABSOLUTE(0xffffffff))
	/*  4 */	LONG(ABSOLUTE(0xffffffff))
	/*  5 */	LONG(ABSOLUTE(0xffffffff))
	/*  6 */	LONG(DEFINED(_int_direct)?ABSOLUTE(_int_direct):ABSOLUTE(0xffffffff))
	/*  7 */	LONG(ABSOLUTE(0xffffffff))	/*  7 NMI vector */
	/*  8 */	LONG(DEFINED(_int_trap0)?ABSOLUTE(_int_trap0):ABSOLUTE(0xffffffff))
	/*  9 */	LONG(DEFINED(_int_trap1)?ABSOLUTE(_int_trap1):ABSOLUTE(0xffffffff))
	/* 10 */	LONG(DEFINED(_int_trap2)?ABSOLUTE(_int_trap2):ABSOLUTE(0xffffffff))
	/* 11 */	LONG(DEFINED(_int_trap3)?ABSOLUTE(_int_trap3):ABSOLUTE(0xffffffff))
	/* 12 */	LONG(ABSOLUTE(0xffffffff))	/* Reserved */
	/* 13 */	LONG(ABSOLUTE(0xffffffff))
	/* 14 */	LONG(ABSOLUTE(0xffffffff))
	/* 15 */	LONG(ABSOLUTE(0xffffffff))
	/* 16 */	LONG(DEFINED(_int_irq0)?ABSOLUTE(_int_irq0):ABSOLUTE(0xffffffff))
	/* 17 */	LONG(DEFINED(_int_irq1)?ABSOLUTE(_int_irq1):ABSOLUTE(0xffffffff))
	/* 18 */	LONG(DEFINED(_int_irq2)?ABSOLUTE(_int_irq2):ABSOLUTE(0xffffffff))
	/* 19 */	LONG(DEFINED(_int_irq3)?ABSOLUTE(_int_irq3):ABSOLUTE(0xffffffff))
	/* 20 */	LONG(DEFINED(_int_irq4)?ABSOLUTE(_int_irq4):ABSOLUTE(0xffffffff))
	/* 21 */	LONG(DEFINED(_int_irq5)?ABSOLUTE(_int_irq5):ABSOLUTE(0xffffffff))
	/* 22 */	LONG(DEFINED(_int_irq6)?ABSOLUTE(_int_irq4):ABSOLUTE(0xffffffff))
	/* 23 */	LONG(DEFINED(_int_irq7)?ABSOLUTE(_int_irq5):ABSOLUTE(0xffffffff))
	/* 24 */	LONG(DEFINED(_int_swdtend)?ABSOLUTE(_int_swdtend):ABSOLUTE(0xffffffff))
	/* 25 */	LONG(DEFINED(_int_wovi0)?ABSOLUTE(_int_wovi0):ABSOLUTE(0xffffffff))
	/* 26 */	LONG(DEFINED(_int_wovi1)?ABSOLUTE(_int_wovi1):ABSOLUTE(0xffffffff))
	/* 27 */	LONG(DEFINED(_int_adrbrk)?ABSOLUTE(_int_adrbrk):ABSOLUTE(0xffffffff))
	/* 28 */	LONG(DEFINED(_int_adi)?ABSOLUTE(_int_adi):ABSOLUTE(0xffffffff))
	/* 29 */	LONG(ABSOLUTE(0xffffffff))	/* Reserved */
	/* 30 */	LONG(ABSOLUTE(0xffffffff))
	/* 31 */	LONG(ABSOLUTE(0xffffffff))
	/* 32 */	LONG(ABSOLUTE(0xffffffff))
	/* 33 */	LONG(ABSOLUTE(0xffffffff))
	/* 34 */	LONG(ABSOLUTE(0xffffffff))
	/* 35 */	LONG(ABSOLUTE(0xffffffff))
	/* 36 */	LONG(ABSOLUTE(0xffffffff))
	/* 37 */	LONG(ABSOLUTE(0xffffffff))
	/* 38 */	LONG(ABSOLUTE(0xffffffff))
	/* 39 */	LONG(ABSOLUTE(0xffffffff))
	/* 40 */	LONG(ABSOLUTE(0xffffffff))
	/* 41 */	LONG(ABSOLUTE(0xffffffff))
	/* 42 */	LONG(ABSOLUTE(0xffffffff))
	/* 43 */	LONG(ABSOLUTE(0xffffffff))
	/* 44 */	LONG(ABSOLUTE(0xffffffff))
	/* 45 */	LONG(ABSOLUTE(0xffffffff))
	/* 46 */	LONG(ABSOLUTE(0xffffffff))
	/* 47 */	LONG(ABSOLUTE(0xffffffff))
	/* 48 */	LONG(DEFINED(_int_icia)?ABSOLUTE(_int_icia):ABSOLUTE(0xffffffff))
	/* 49 */	LONG(DEFINED(_int_icib)?ABSOLUTE(_int_icib):ABSOLUTE(0xffffffff))
	/* 50 */	LONG(DEFINED(_int_icic)?ABSOLUTE(_int_icic):ABSOLUTE(0xffffffff))
	/* 51 */	LONG(DEFINED(_int_icid)?ABSOLUTE(_int_icid):ABSOLUTE(0xffffffff))
	/* 52 */	LONG(DEFINED(_int_ocia)?ABSOLUTE(_int_ocia):ABSOLUTE(0xffffffff))
	/* 53 */	LONG(DEFINED(_int_ocib)?ABSOLUTE(_int_ocib):ABSOLUTE(0xffffffff))
	/* 54 */	LONG(DEFINED(_int_fovi)?ABSOLUTE(_int_fovi):ABSOLUTE(0xffffffff))
	/* 55 */	LONG(ABSOLUTE(0xffffffff))	/* Reserved */
	/* 56 */	LONG(ABSOLUTE(0xffffffff))
	/* 57 */	LONG(ABSOLUTE(0xffffffff))
	/* 58 */	LONG(ABSOLUTE(0xffffffff))
	/* 59 */	LONG(ABSOLUTE(0xffffffff))
	/* 60 */	LONG(ABSOLUTE(0xffffffff))
	/* 61 */	LONG(ABSOLUTE(0xffffffff))
	/* 62 */	LONG(ABSOLUTE(0xffffffff))
	/* 63 */	LONG(ABSOLUTE(0xffffffff))
	/* 64 */	LONG(DEFINED(_int_cmia0)?ABSOLUTE(_int_cmia0):ABSOLUTE(0xffffffff))
	/* 65 */	LONG(DEFINED(_int_cmib0)?ABSOLUTE(_int_cmib0):ABSOLUTE(0xffffffff))
	/* 66 */	LONG(DEFINED(_int_ovi0)?ABSOLUTE(_int_ovi0):ABSOLUTE(0xffffffff))
	/* 67 */	LONG(ABSOLUTE(0xffffffff))	/* Reserved */
	/* 68 */	LONG(DEFINED(_int_cmia1)?ABSOLUTE(_int_cmia1):ABSOLUTE(0xffffffff))
	/* 69 */	LONG(DEFINED(_int_cmib1)?ABSOLUTE(_int_cmib1):ABSOLUTE(0xffffffff))
	/* 70 */	LONG(DEFINED(_int_ovi1)?ABSOLUTE(_int_ovi1):ABSOLUTE(0xffffffff))
	/* 71 */	LONG(ABSOLUTE(0xffffffff))	/* Reserved */
	/* 72 */	LONG(DEFINED(_int_cmiay)?ABSOLUTE(_int_cmiay):ABSOLUTE(0xffffffff))
	/* 73 */	LONG(DEFINED(_int_cmiby)?ABSOLUTE(_int_cmiby):ABSOLUTE(0xffffffff))
	/* 74 */	LONG(DEFINED(_int_oviy)?ABSOLUTE(_int_oviy):ABSOLUTE(0xffffffff))
	/* 75 */	LONG(DEFINED(_int_icix)?ABSOLUTE(_int_icix):ABSOLUTE(0xffffffff))
	/* 76 */	LONG(ABSOLUTE(0xffffffff))	/* Reserved */
	/* 77 */	LONG(ABSOLUTE(0xffffffff))
	/* 78 */	LONG(ABSOLUTE(0xffffffff))
	/* 79 */	LONG(ABSOLUTE(0xffffffff))
	/* 80 */	LONG(DEFINED(_int_eri0)?ABSOLUTE(_int_eri0):ABSOLUTE(0x0))
	/* 81 */	LONG(DEFINED(_int_rxi0)?ABSOLUTE(_int_rxi0):ABSOLUTE(0x0))
	/* 82 */	LONG(DEFINED(_int_txi0)?ABSOLUTE(_int_txi0):ABSOLUTE(0x0))
	/* 83 */	LONG(DEFINED(_int_tei0)?ABSOLUTE(_int_tei0):ABSOLUTE(0x0))
	/* 84 */	LONG(DEFINED(_int_eri1)?ABSOLUTE(_int_eri1):ABSOLUTE(0x0))
	/* 85 */	LONG(DEFINED(_int_rxi1)?ABSOLUTE(_int_rxi1):ABSOLUTE(0x0))
	/* 86 */	LONG(DEFINED(_int_txi1)?ABSOLUTE(_int_txi1):ABSOLUTE(0x0))
	/* 87 */	LONG(DEFINED(_int_tei1)?ABSOLUTE(_int_tei1):ABSOLUTE(0x0))
	/* 88 */	LONG(DEFINED(_int_eri2)?ABSOLUTE(_int_eri2):ABSOLUTE(0xffffffff))
	/* 89 */	LONG(DEFINED(_int_rxi2)?ABSOLUTE(_int_rxi2):ABSOLUTE(0xffffffff))
	/* 90 */	LONG(DEFINED(_int_txi2)?ABSOLUTE(_int_txi2):ABSOLUTE(0xffffffff))
	/* 91 */	LONG(DEFINED(_int_tei2)?ABSOLUTE(_int_tei2):ABSOLUTE(0xffffffff))
	/* 92 */	LONG(DEFINED(_int_iici0)?ABSOLUTE(_int_iici0):ABSOLUTE(0xffffffff))
	/* 93 */	LONG(DEFINED(_int_ddcswi)?ABSOLUTE(_int_ddcswi):ABSOLUTE(0xffffffff))
	/* 94 */	LONG(DEFINED(_int_iici1)?ABSOLUTE(_int_iici1):ABSOLUTE(0xffffffff))
	/* 95 */	LONG(ABSOLUTE(0xffffffff))	/* Reserved */
	/* 96 */	LONG(ABSOLUTE(0xffffffff))
	/* 97 */	LONG(ABSOLUTE(0xffffffff))
	/* 98 */	LONG(ABSOLUTE(0xffffffff))
	/* 99 */	LONG(ABSOLUTE(0xffffffff))
	/*100 */	LONG(ABSOLUTE(0xffffffff))
	/*101 */	LONG(ABSOLUTE(0xffffffff))
	/*102 */	LONG(ABSOLUTE(0xffffffff))
	/*103 */	LONG(ABSOLUTE(0xffffffff))
	} >sysvec
	/* Stabs debugging sections.  */
	.stab          0 : { *(.stab) }
	.stabstr       0 : { *(.stabstr) }
	.stab.excl     0 : { *(.stab.excl) }
	.stab.exclstr  0 : { *(.stab.exclstr) }
	.stab.index    0 : { *(.stab.index) }
	.stab.indexstr 0 : { *(.stab.indexstr) }
	.comment       0 : { *(.comment) }
	/* DWARF debug sections.
	Symbols in the DWARF debugging sections are relative to the beginning
	of the section so we begin them at 0.  */
	/* DWARF 1 */
	.debug          0 : { *(.debug) }
	.line           0 : { *(.line) }
	.debug_srcinfo  0 : { *(.debug_srcinfo) }
	.debug_sfnames  0 : { *(.debug_sfnames) }
	/* DWARF 1.1 and DWARF 2 */
	.debug_aranges  0 : { *(.debug_aranges) }
	.debug_pubnames 0 : { *(.debug_pubnames) }
	/* DWARF 2 */
	.debug_info     0 : { *(.debug_info .gnu.linkonce.wi.*) }
	.debug_abbrev   0 : { *(.debug_abbrev) }
	.debug_line     0 : { *(.debug_line) }
	.debug_frame    0 : { *(.debug_frame) }
	.debug_str      0 : { *(.debug_str) }
	.debug_loc      0 : { *(.debug_loc) }
	.debug_macinfo  0 : { *(.debug_macinfo) }
	.debug_weaknames 0 : { *(.debug_weaknames) }
	.debug_funcnames 0 : { *(.debug_funcnames) }
	.debug_typenames 0 : { *(.debug_typenames) }
	.debug_varnames  0 : { *(.debug_varnames) }
}
