#ifndef	_H8S_2128S_H_
#define	_H8S_2128S_H_	1
typedef	char            _s8;
typedef	unsigned char   _u8;
typedef	unsigned short _u16;
/* modified variable types to type defind 2011/09/01 */
/************************************************************************/
/*      H8S/2128 Series Include File                       Ver 2.0      */
/************************************************************************/
union un_kbcomp {                                       /* union KBCOMP */
                _u8           BYTE;                     /*  Byte Access */
                struct {                                /*  Bit  Access */
                       _u8           IrE  :1;           /*    IrE       */
                       _u8           IrCKS:3;           /*    IrCKS     */
                       _u8           KBADE:1;           /*    KBADE     */
                       _u8           KBCH :3;           /*    KBCH      */
                       }      BIT;                      /*              */
};                                                      /*              */
struct st_iic {                                         /* struct IIC   */
              union {                                   /* ICCR         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           ICE :1;        /*    ICE       */
                           _u8           IEIC:1;        /*    IEIC      */
                           _u8           MST :1;        /*    MST       */
                           _u8           TRS :1;        /*    TRS       */
                           _u8           ACKE:1;        /*    ACKE      */
                           _u8           BBSY:1;        /*    BBSY      */
                           _u8           IRIC:1;        /*    IRIC      */
                           _u8           SCP :1;        /*    SCP       */
                           }      BIT;                  /*              */
                    }           ICCR;                   /*              */
              union {                                   /* ICSR         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           ESTP:1;        /*    ESTP      */
                           _u8           STOP:1;        /*    STOP      */
                           _u8           IRTR:1;        /*    IRTR      */
                           _u8           AASX:1;        /*    AASX      */
                           _u8           AL  :1;        /*    AL        */
                           _u8           AAS :1;        /*    AAS       */
                           _u8           ADZ :1;        /*    ADZ       */
                           _u8           ACKB:1;        /*    ACKB      */
                           }      BIT;                  /*              */
                    }           ICSR;                   /*              */
              _s8               wk[4];                  /*              */
              union {                                   /*              */
                    struct {                            /*              */
                           union {                      /* SARX         */
                                 _u8           BYTE;    /*  Byte Access */
                                 struct {               /*  Bit  Access */
                                        _u8     SVAX:7; /*    SVAX      */
                                        _u8     FSX :1; /*    FSX       */
                                        }      BIT;     /*              */
                                 } UN_SARX;             /*              */
                           union {                      /* SAR          */
                                 _u8           BYTE;    /*  Byte Access */
                                 struct {               /*  Bit  Access */
                                        _u8     SVA:7;  /*    SVA       */
                                        _u8     FS :1;  /*    FS        */
                                        }      BIT;     /*              */
                                 } UN_SAR;              /*              */
                           } ICE0;                      /*              */
                    struct {                            /*              */
                           _u8           UN_ICDR;       /* ICDR         */
                           union {                      /* ICMR         */
                                 _u8           BYTE;    /*  Byte Access */
                                 struct {               /*  Bit  Access */
                                        _u8    MLS :1;  /*    MLS       */
                                        _u8    WAIT:1;  /*    WAIT      */
                                        _u8    CKS :3;  /*    CKS       */
                                        _u8    BC  :3;  /*    BC        */
                                        }      BIT;     /*              */
                                 }       UN_ICMR;       /*              */
                           } ICE1;                      /*              */
                    }           EQU;                    /*              */
};                                                      /*              */
union un_ddcswr {                                       /* union DDCSWR */
                _u8           BYTE;                     /*  Byte Access */
                struct {                                /*  Bit  Access */
                       _u8           SWE:1;             /*    SWE       */
                       _u8           SW :1;             /*    SW        */
                       _u8           IE :1;             /*    IE        */
                       _u8           IF :1;             /*    IF        */
                       _u8           CLR:4;             /*    CLR       */
                       }      BIT;                      /*              */
};                                                      /*              */
struct st_intc {                                        /* struct INTC  */
               union {                                  /* ICRA         */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           _IRQ0:1;      /*    IRQ0      */
                            _u8           _IRQ1:1;      /*    IRQ1      */
                            _u8           _IRQ2:1;      /*    IRQ2      */
                            _u8                :2;      /*              */
                            _u8           _DTC :1;      /*    DTC       */
                            _u8           _WDT0:1;      /*    WDT0      */
                            _u8           _WDT1:1;      /*    WDT1      */
                            }      BIT;                 /*              */
                     }          ICRA;                   /*              */
               union {                                  /* ICRB         */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           _AD   :1;     /*    A/D       */
                            _u8           _FRT  :1;     /*    FRT       */
                            _u8                 :2;     /*              */
                            _u8           _TMR0 :1;     /*    TMR0      */
                            _u8           _TMR1 :1;     /*    TMR1      */
                            _u8           _TMRXY:1;     /*    TMRX,Y    */
                            }      BIT;                 /*              */
                     }          ICRB;                   /*              */
               union {                                  /* ICRC         */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           _SCI0:1;      /*    SCI0      */
                            _u8           _SCI1:1;      /*    SCI1      */
                            _u8                :2;      /*              */
                            _u8           _IIC0:1;      /*    IIC0      */
                            _u8           _IIC1:1;      /*    IIC1      */
                            }      BIT;                 /*              */
                     }          ICRC;                   /*              */
               union {                                  /* ISR          */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8                :5;      /*              */
                            _u8           IRQ2F:1;      /*    IRQ2F     */
                            _u8           IRQ1F:1;      /*    IRQ1F     */
                            _u8           IRQ0F:1;      /*    IRQ0F     */
                            }      BIT;                 /*              */
                     }          ISR;                    /*              */
               union {                                  /* ISCR         */
                     _u16         WORD;                 /*  Word Access */
                     struct {                           /*  Byte Access */
                            _u8           H;            /*    ISCRH     */
                            _u8           L;            /*    ISCRL     */
                            }     BYTE;                 /*              */
                     struct {                           /*  Bit  Access */
                            _u8                 :8;     /*              */
                            _u8                 :2;     /*              */
                            _u8           IRQ2SC:2;     /*    IRQ2SC    */
                            _u8           IRQ1SC:2;     /*    IRQ1SC    */
                            _u8           IRQ0SC:2;     /*    IRQ0SC    */
                            }     BIT;                  /*              */
                     }          ISCR;                   /*              */
               _s8              wk1[6];                 /*              */
               union {                                  /* ABRKCR       */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           CMF:1;        /*    CMF       */
                            _u8              :6;        /*              */
                            _u8           BIE:1;        /*    BIE       */
                            }      BIT;                 /*              */
                     }          ABRKCR;                 /*              */
               _u8              BARA;                   /* BARA         */
               _u8              BARB;                   /* BARB         */
               _u8              BARC;                   /* BARC         */
               _s8              wk2[202];               /*              */
               union {                                  /* IER          */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8                :5;      /*              */
                            _u8           IRQ2E:1;      /*    IRQ2E     */
                            _u8           IRQ1E:1;      /*    IRQ1E     */
                            _u8           IRQ0E:1;      /*    IRQ0E     */
                            }      BIT;                 /*              */
                     }          IER;                    /*              */
};                                                      /*              */
struct st_dtc {                                         /* struct DTC   */
              union {                                   /* DTCEA        */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           IRQ0:1;        /*    IRQ0      */
                           _u8           IRQ1:1;        /*    IRQ1      */
                           _u8           IRQ2:1;        /*    IRQ2      */
                           _u8               :1;        /*              */
                           _u8           ADI :1;        /*    A/D ADI   */
                           _u8           ICIA:1;        /*    FRT ICIA  */
                           _u8           ICIB:1;        /*    FRT ICIB  */
                           _u8           OCIA:1;        /*    FRT OCIA  */
                           }      BIT;                  /*              */
                    }           DTCEA;                  /*              */
              union {                                   /* DTCEB           */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           OCIB :1;       /*    FRT OCIB  */
                           _u8                :4;       /*              */
                           _u8           CMIA0:1;       /*    TMR0 CMIA */
                           _u8           CMIB0:1;       /*    TMR0 CMIB */
                           _u8           CMIA1:1;       /*    TMR1 CMIA */
                           }      BIT;                  /*              */
                    }           DTCEB;                  /*              */
              union {                                   /* DTCEC           */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           CMIB1:1;       /*    TMR1 CMIB */
                           _u8           CMIAY:1;       /*    TMRY CMIA */
                           _u8           CMIBY:1;       /*    TMRY CMIB */
                           _u8                :2;       /*              */
                           _u8           RXI0 :1;       /*    SCI0 RXI  */
                           _u8           TXI0 :1;       /*    SCI0 TXI  */
                           _u8           RXI1 :1;       /*    SCI1 RXI  */
                           }      BIT;                  /*              */
                    }           DTCEC;                  /*              */
              union {                                   /* DTCED           */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           TXI1 :1;       /*    SCI1 TXI  */
                           _u8                :2;       /*              */
                           _u8           IICI0:1;       /*    IIC0 IICI */
                           _u8           IICI1:1;       /*    IIC1 IICI */
                           }      BIT;                  /*              */
                    }           DTCED;                  /*              */
              _s8               wk;                     /*              */
              union {                                   /* DTVECR       */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           SWDTE:1;       /*    SWDTE     */
                           _u8           DTVEC:7;       /*    DTVEC     */
                           }      BIT;                  /*              */
                    }           DTVECR;                 /*              */
};                                                      /*              */
struct st_flash {                                       /* struct FLASH */
                union {                                 /* FLMCR1       */
                      _u8           BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             _u8           FWE:1;       /*    FWE       */
                             _u8           SWE:1;       /*    SWE       */
                             _u8              :2;       /*              */
                             _u8           EV :1;       /*    EV        */
                             _u8           PV :1;       /*    PV        */
                             _u8           E  :1;       /*    E         */
                             _u8           P  :1;       /*    P         */
                             }      BIT;                /*              */
                      }         FLMCR1;                 /*              */
                union {                                 /* FLMCR2       */
                      _u8           BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             _u8           FLER:1;      /*    FLER      */
                             _u8               :5;      /*              */
                             _u8           ESU :1;      /*    ESU       */
                             _u8           PSU :1;      /*    PSU       */
                             }      BIT;                /*              */
                      }         FLMCR2;                 /*              */
                union {                                 /* EBR1         */
                      _u8           BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             _u8              :6;       /*              */
                             _u8           EB9:1;       /*    EB9       */
                             _u8           EB8:1;       /*    EB8       */
                             }      BIT;                /*              */
                      }         EBR1;                   /*              */
                union {                                 /* EBR2         */
                      _u8           BYTE;               /*  Byte Access */
                      struct {                          /*  Bit  Access */
                             _u8           EB7:1;       /*    EB7       */
                             _u8           EB6:1;       /*    EB6       */
                             _u8           EB5:1;       /*    EB5       */
                             _u8           EB4:1;       /*    EB4       */
                             _u8           EB3:1;       /*    EB3       */
                             _u8           EB2:1;       /*    EB2       */
                             _u8           EB1:1;       /*    EB1       */
                             _u8           EB0:1;       /*    EB0       */
                             }      BIT;                /*              */
                      }         EBR2;                   /*              */
};                                                      /*              */
struct st_pwm {                                         /* struct PWM   */
              union {                                   /* PCSR         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8                :5;       /*              */
                           _u8           PWCKB:1;       /*    PWCKB     */
                           _u8           PWCKA:1;       /*    PWCKA     */
                           }      BIT;                  /*              */
                    }           PCSR;                   /*              */
              _s8               wk[79];                 /*              */
              union {                                   /* PWOER        */
                    _u16         WORD;                  /*  Word Access */
                    struct {                            /*  Byte Access */
                           _u8           B;             /*    PWOERB    */
                           _u8           A;             /*    PWOERA    */
                           }     BYTE;                  /*              */
                    struct {                            /*  Bit  Access */
                           _u8           OE15:1;        /*    OE15      */
                           _u8           OE14:1;        /*    OE14      */
                           _u8           OE13:1;        /*    OE13      */
                           _u8           OE12:1;        /*    OE12      */
                           _u8           OE11:1;        /*    OE11      */
                           _u8           OE10:1;        /*    OE10      */
                           _u8           OE9 :1;        /*    OE9       */
                           _u8           OE8 :1;        /*    OE8       */
                           _u8           OE7 :1;        /*    OE7       */
                           _u8           OE6 :1;        /*    OE6       */
                           _u8           OE5 :1;        /*    OE5       */
                           _u8           OE4 :1;        /*    OE4       */
                           _u8           OE3 :1;        /*    OE3       */
                           _u8           OE2 :1;        /*    OE2       */
                           _u8           OE1 :1;        /*    OE1       */
                           _u8           OE0 :1;        /*    OE0       */
                           }     BIT;                   /*              */
                    }           PWOER;                  /*              */
              union {                                   /* PWDPR        */
                    _u16         WORD;                  /*  Word Access */
                    struct {                            /*  Byte Access */
                           _u8           B;             /*    PWDPRB    */
                           _u8           A;             /*    PWDPRA    */
                           }     BYTE;                  /*              */
                    struct {                            /*  Bit  Access */
                           _u8           OS15:1;        /*    OS15      */
                           _u8           OS14:1;        /*    OS14      */
                           _u8           OS13:1;        /*    OS13      */
                           _u8           OS12:1;        /*    OS12      */
                           _u8           OS11:1;        /*    OS11      */
                           _u8           OS10:1;        /*    OS10      */
                           _u8           OS9 :1;        /*    OS9       */
                           _u8           OS8 :1;        /*    OS8       */
                           _u8           OS7 :1;        /*    OS7       */
                           _u8           OS6 :1;        /*    OS6       */
                           _u8           OS5 :1;        /*    OS5       */
                           _u8           OS4 :1;        /*    OS4       */
                           _u8           OS3 :1;        /*    OS3       */
                           _u8           OS2 :1;        /*    OS2       */
                           _u8           OS1 :1;        /*    OS1       */
                           _u8           OS0 :1;        /*    OS0       */
                           }     BIT;                   /*              */
                    }           PWDPR;                  /*              */
              union {                                   /* PWSL         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           PWCKE:1;       /*    PWCKE     */
                           _u8           PWCKS:1;       /*    PWCKS     */
                           _u8                :2;       /*              */
                           _u8           RS   :4;       /*    RS        */
                           }      BIT;                  /*              */
                    }           PWSL;                   /*              */
              _u8               PWDR;                   /* PWDR0-PWDR15 */
};                                                      /*              */
union un_sbycr {                                        /* union SBYCR  */
               _u8           BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      _u8           SSBY:1;             /*    SSBY      */
                      _u8           STS :3;             /*    STS       */
                      _u8               :1;             /*              */
                      _u8           SCK :3;             /*    SCK       */
                      }      BIT;                       /*              */
};                                                      /*              */
union un_lpwrcr {                                       /* union LPWRCR */
                _u8           BYTE;                     /*  Byte Access */
                struct {                                /*  Bit  Access */
                       _u8           DTON :1;           /*    DTON      */
                       _u8           LSON :1;           /*    LSON      */
                       _u8           NESEL:1;           /*    NESEL     */
                       _u8           EXCLE:1;           /*    EXCLE     */
                       }      BIT;                      /*              */
};                                                      /*              */
union un_mstpcr {                                       /* union MSTPCR */
                _u16         WORD;                      /*  Word Access */
                struct {                                /*  Byte Access */
                       _u8           H;                 /*    MSTPCRH   */
                       _u8           L;                 /*    MSTPCRL   */
                       }     BYTE;                      /*              */
                struct {                                /*  Bit  Access */
                       _u8                 :1;          /*              */
                       _u8           _DTC  :1;          /*    DTC       */
                       _u8           _FRT  :1;          /*    FRT       */
                       _u8           _TMR01:1;          /*    TMR0,TMR1 */
                       _u8           _PWMX :1;          /*    PWM,PWMX  */
                       _u8                 :1;          /*              */
                       _u8           _AD   :1;          /*    A/D       */
                       _u8           _TMRXY:1;          /*    TMRX,TMRY */
                       _u8           _SCI0 :1;          /*    SCI0      */
                       _u8           _SCI1 :1;          /*    SCI1      */
                       _u8                 :1;          /*              */
                       _u8           _IIC0 :1;          /*    IIC0      */
                       _u8           _IIC1 :1;          /*    IIC1      */
                       }     BIT;                       /*              */
};                                                      /*              */
union un_stcr {                                         /* union STCR   */
              _u8           BYTE;                       /*  Byte Access */
              struct {                                  /*  Bit  Access */
                     _u8           IICS :1;             /*    IICS      */
                     _u8           IICX1:1;             /*    IICX1     */
                     _u8           IICX0:1;             /*    IICX0     */
                     _u8           IICE :1;             /*    IICE      */
                     _u8           FLSHE:1;             /*    FLSHE     */
                     _u8                :1;             /*              */
                     _u8           ICKS1:1;             /*    ICKS1     */
                     _u8           ICKS0:1;             /*    ICKS0     */
                     }      BIT;                        /*              */
};                                                      /*              */
union un_syscr {                                        /* union SYSCR  */
               _u8           BYTE;                      /*  Byte Access */
               struct {                                 /*  Bit  Access */
                      _u8           CS2E :1;            /*    CS2E      */
                      _u8           IOSE :1;            /*    IOSE      */
                      _u8           INTM :2;            /*    INTM      */
                      _u8           XRST :1;            /*    XRST      */
                      _u8           NMIEG:1;            /*    NMIEG     */
                      _u8           HIE  :1;            /*    HIE       */
                      _u8           RAME :1;            /*    RAME      */
                      }      BIT;                       /*              */
};                                                      /*              */
union un_mdcr {                                         /* union MDCR   */
              _u8           BYTE;                       /*  Byte Access */
              struct {                                  /*  Bit  Access */
                     _u8           EXPE:1;              /*    EXPE      */
                     _u8               :5;              /*              */
                     _u8           MDS :2;              /*    MDS       */
                     }      BIT;                        /*              */
};                                                      /*              */
struct st_sci {                                         /* struct SCI   */
              union {                                   /* SMR          */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           CA  :1;        /*    C/A       */
                           _u8           CHR :1;        /*    CHR       */
                           _u8           PE  :1;        /*    PE        */
                           _u8           OE  :1;        /*    O/E       */
                           _u8           STOP:1;        /*    STOP      */
                           _u8           MP  :1;        /*    MP        */
                           _u8           CKS :2;        /*    CKS       */
                           }      BIT;                  /*              */
                    }           SMR;                    /*              */
              _u8               BRR;                    /* BRR          */
              union {                                   /* SCR          */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           TIE :1;        /*    TIE       */
                           _u8           RIE :1;        /*    RIE       */
                           _u8           TE  :1;        /*    TE        */
                           _u8           RE  :1;        /*    RE        */
                           _u8           MPIE:1;        /*    MPIE      */
                           _u8           TEIE:1;        /*    TEIE      */
                           _u8           CKE :2;        /*    CKE       */
                           }      BIT;                  /*              */
                    }           SCR;                    /*              */
              _u8               TDR;                    /* TDR          */
              union {                                   /* SSR          */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           TDRE:1;        /*    TDRE      */
                           _u8           RDRF:1;        /*    RDRF      */
                           _u8           ORER:1;        /*    ORER      */
                           _u8           FER :1;        /*    FER       */
                           _u8           PER :1;        /*    PER       */
                           _u8           TEND:1;        /*    TEND      */
                           _u8           MPB :1;        /*    MPB       */
                           _u8           MPBT:1;        /*    MPBT      */
                           }      BIT;                  /*              */
                    }           SSR;                    /*              */
              _u8               RDR;                    /* RDR          */
              union {                                   /* SCMR         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8               :4;        /*              */
                           _u8           SDIR:1;        /*    SDIR      */
                           _u8           SINV:1;        /*    SINV      */
                           _u8               :1;        /*              */
                           _u8           SMIF:1;        /*    SMIF      */
                           }      BIT;                  /*              */
                    }           SCMR;                   /*              */
};                                                      /*              */
struct st_frt {                                         /* struct FRT   */
              union {                                   /* TIER         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           ICIAE:1;       /*    ICIAE     */
                           _u8           ICIBE:1;       /*    ICIBE     */
                           _u8           ICICE:1;       /*    ICICE     */
                           _u8           ICIDE:1;       /*    ICIDE     */
                           _u8           OCIAE:1;       /*    OCIAE     */
                           _u8           OCIBE:1;       /*    OCIBE     */
                           _u8           OVIE :1;       /*    OVIE      */
                           }      BIT;                  /*              */
                    }           TIER;                   /*              */
              union {                                   /* TCSR         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           ICFA :1;       /*    ICFA      */
                           _u8           ICFB :1;       /*    ICFB      */
                           _u8           ICFC :1;       /*    ICFC      */
                           _u8           ICFD :1;       /*    ICFD      */
                           _u8           OCFA :1;       /*    OCFA      */
                           _u8           OCFB :1;       /*    OCFB      */
                           _u8           OVF  :1;       /*    OVF       */
                           _u8           CCLRA:1;       /*    CCLRA     */
                           }      BIT;                  /*              */
                    }           TCSR;                   /*              */
              _u16              FRC;                    /* FRC          */
              _u16              OCRA;                   /* OCRA or OCRB */
              union {                                   /* TCR          */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           IEDGA:1;       /*    IEDGA     */
                           _u8           IEDGB:1;       /*    IEDGB     */
                           _u8           IEDGC:1;       /*    IEDGC     */
                           _u8           IEDGD:1;       /*    IEDGD     */
                           _u8           BUFEA:1;       /*    BUFEA     */
                           _u8           BUFEB:1;       /*    BUFEB     */
                           _u8           CKS  :2;       /*    CKS       */
                           }      BIT;                  /*              */
                    }           TCR;                    /*              */
              union {                                   /* TOCR         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           ICRDMS:1;      /*    ICRDMS    */
                           _u8           OCRAMS:1;      /*    OCRAMS    */
                           _u8           ICRS  :1;      /*    ICRS      */
                           _u8           OCRS  :1;      /*    OCRS      */
                           _u8           OEA   :1;      /*    OEA       */
                           _u8           OEB   :1;      /*    OEB       */
                           _u8           OLVLA :1;      /*    OLVLA     */
                           _u8           OLVLB :1;      /*    OLVLB     */
                           }      BIT;                  /*              */
                    }           TOCR;                   /*              */
              _u16              ICRA;                   /* ICRA or OCRAR*/
              _u16              ICRB;                   /* ICRB or OCRAF*/
              _u16              ICRC;                   /* ICRC or OCRDM*/
              _u16              ICRD;                   /* ICRD         */
};                                                      /*              */
union un_pwmx {                                         /* struct PWMX  */
              struct {                                  /*              */
                     union {                            /* DACR         */
                           _u8           BYTE;          /*  Byte Access */
                           struct {                     /*  Bit  Access */
                                  _u8           TEST:1; /*    TEST      */
                                  _u8           PWME:1; /*    PWME      */
                                  _u8               :2; /*              */
                                  _u8           OEB :1; /*    OEB       */
                                  _u8           OEA :1; /*    OEA       */
                                  _u8           OS  :1; /*    OS        */
                                  _u8           CKS :1; /*    CKS       */
                                  }      BIT;           /*              */
                           } ST_DACR;                   /*              */
                     _s8     wk[5];                     /*              */
                     union {                            /* DACNT        */
                           _u16         WORD;           /*  Word Access */
                           struct {                     /*  Bit  Access */
                                  _u16             :15; /*              */
                                  _u16         REGS: 1; /*    REGS      */
                                  }     BIT;            /*              */
                           } ST_DACNT;                  /*              */
                     } REGS1;                           /*              */
              struct {                                  /*              */
                     union {                            /* DADRA        */
                           _u16         WORD;           /*  Word Access */
                           struct {                     /*  Bit  Access */
                                  _u16            :14;  /*              */
                                  _u16         CFS: 1;  /*    CFS       */
                                  }      BIT;           /*              */
                           } ST_DADRA;                  /*              */
                     _s8     wk[4];                     /*              */
                     union {                            /* DADRB        */
                           _u16         WORD;           /*  Word Access */
                           struct {                     /*  Bit  Access */
                                  _u16             :14; /*              */
                                  _u16         CFS : 1; /*    CFS       */
                                  _u16         REGS: 1; /*    REGS      */
                                  }     BIT;            /*              */
                           } ST_DADRB;                  /*              */
                     } REGS0;                           /*              */
};                                                      /*              */
union un_wdt0 {                                         /* union WDT0   */
             struct {                                   /* Read  Access */
                    union {                             /* TCSR         */
                          _u8           BYTE;           /*  Byte Access */
                          struct {                      /*  Bit  Access */
                                 _u8           OVF   :1;/*    OVF       */
                                 _u8           WTIT  :1;/*    WT/IT     */
                                 _u8           TME   :1;/*    TME       */
                                 _u8           RSTS  :1;/*    RSTS      */
                                 _u8           RSTNMI:1;/*    RST/NMI   */
                                 _u8           CKS   :3;/*    CKS       */
                                 }      BIT;            /*              */
                          }       TCSR;                 /*              */
                    _u8           TCNT;                 /* TCNT         */
                    } READ;                             /*              */
             union  {                                   /* Write Access */
                    _u16          TCSR;                 /* TCSR         */
                    _u16          TCNT;                 /* TCNT         */
                    } WRITE;                            /*              */
};                                                      /*              */
union un_wdt1 {                                         /* union WDT1   */
             struct {                                   /* Read  Access */
                    union {                             /* TCSR         */
                          _u8           BYTE;           /*  Byte Access */
                          struct {                      /*  Bit  Access */
                                 _u8           OVF   :1;/*    OVF       */
                                 _u8           WTIT  :1;/*    WT/IT     */
                                 _u8           TME   :1;/*    TME       */
                                 _u8           PSS   :1;/*    PSS       */
                                 _u8           RSTNMI:1;/*    RST/NMI   */
                                 _u8           CKS   :3;/*    CKS       */
                                 }      BIT;            /*              */
                          }       TCSR;                 /*              */
                    _u8           TCNT;                 /* TCNT         */
                    } READ;                             /*              */
             union  {                                   /* Write Access */
                    _u16          TCSR;                 /* TCSR         */
                    _u16          TCNT;                 /* TCNT         */
                    } WRITE;                            /*              */
};                                                      /*              */
struct st_p1 {                                          /* struct P1    */
             union {                                    /* P1PCR        */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           B7:1;           /*    Bit 7     */
                          _u8           B6:1;           /*    Bit 6     */
                          _u8           B5:1;           /*    Bit 5     */
                          _u8           B4:1;           /*    Bit 4     */
                          _u8           B3:1;           /*    Bit 3     */
                          _u8           B2:1;           /*    Bit 2     */
                          _u8           B1:1;           /*    Bit 1     */
                          _u8           B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             _s8                wk1[3];                 /*              */
             _u8                DDR;                    /* P1DDR        */
             _s8                wk2;                    /*              */
             union {                                    /* P1DR         */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           B7:1;           /*    Bit 7     */
                          _u8           B6:1;           /*    Bit 6     */
                          _u8           B5:1;           /*    Bit 5     */
                          _u8           B4:1;           /*    Bit 4     */
                          _u8           B3:1;           /*    Bit 3     */
                          _u8           B2:1;           /*    Bit 2     */
                          _u8           B1:1;           /*    Bit 1     */
                          _u8           B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p2 {                                          /* struct P2    */
             union {                                    /* P2PCR        */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           B7:1;           /*    Bit 7     */
                          _u8           B6:1;           /*    Bit 6     */
                          _u8           B5:1;           /*    Bit 5     */
                          _u8           B4:1;           /*    Bit 4     */
                          _u8           B3:1;           /*    Bit 3     */
                          _u8           B2:1;           /*    Bit 2     */
                          _u8           B1:1;           /*    Bit 1     */
                          _u8           B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             _s8                wk1[3];                 /*              */
             _u8                DDR;                    /* P2DDR        */
             _s8                wk2;                    /*              */
             union {                                    /* P2DR         */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           B7:1;           /*    Bit 7     */
                          _u8           B6:1;           /*    Bit 6     */
                          _u8           B5:1;           /*    Bit 5     */
                          _u8           B4:1;           /*    Bit 4     */
                          _u8           B3:1;           /*    Bit 3     */
                          _u8           B2:1;           /*    Bit 2     */
                          _u8           B1:1;           /*    Bit 1     */
                          _u8           B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p3 {                                          /* struct P3    */
             union {                                    /* P3PCR        */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           B7:1;           /*    Bit 7     */
                          _u8           B6:1;           /*    Bit 6     */
                          _u8           B5:1;           /*    Bit 5     */
                          _u8           B4:1;           /*    Bit 4     */
                          _u8           B3:1;           /*    Bit 3     */
                          _u8           B2:1;           /*    Bit 2     */
                          _u8           B1:1;           /*    Bit 1     */
                          _u8           B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PCR;                    /*              */
             _s8                wk1[5];                 /*              */
             _u8                DDR;                    /* P3DDR        */
             _s8                wk2;                    /*              */
             union {                                    /* P3DR         */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           B7:1;           /*    Bit 7     */
                          _u8           B6:1;           /*    Bit 6     */
                          _u8           B5:1;           /*    Bit 5     */
                          _u8           B4:1;           /*    Bit 4     */
                          _u8           B3:1;           /*    Bit 3     */
                          _u8           B2:1;           /*    Bit 2     */
                          _u8           B1:1;           /*    Bit 1     */
                          _u8           B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p4 {                                          /* struct P4    */
             _u8                DDR;                    /* P4DDR        */
             _s8                wk;                     /*              */
             union {                                    /* P4DR         */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           B7:1;           /*    Bit 7     */
                          _u8           B6:1;           /*    Bit 6     */
                          _u8           B5:1;           /*    Bit 5     */
                          _u8           B4:1;           /*    Bit 4     */
                          _u8           B3:1;           /*    Bit 3     */
                          _u8           B2:1;           /*    Bit 2     */
                          _u8           B1:1;           /*    Bit 1     */
                          _u8           B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p5 {                                          /* struct P5    */
             _u8                DDR;                    /* P5DDR        */
             _s8                wk;                     /*              */
             union {                                    /* P5DR         */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8             :3;           /*    Bit 7-5   */
                          _u8           B4:1;           /*  Bit 4 dummy */
                          _u8           B3:1;           /*  Bit 3 dummy */
                          _u8           B2:1;           /*    Bit 2     */
                          _u8           B1:1;           /*    Bit 1     */
                          _u8           B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p6 {                                          /* struct P6    */
             _u8                DDR;                    /* P6DDR        */
             _s8                wk;                     /*              */
             union {                                    /* P6DR         */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           B7:1;           /*    Bit 7     */
                          _u8           B6:1;           /*    Bit 6     */
                          _u8           B5:1;           /*    Bit 5     */
                          _u8           B4:1;           /*    Bit 4     */
                          _u8           B3:1;           /*    Bit 3     */
                          _u8           B2:1;           /*    Bit 2     */
                          _u8           B1:1;           /*    Bit 1     */
                          _u8           B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            DR;                     /*              */
};                                                      /*              */
struct st_p7 {                                          /* struct P7    */
             union {                                    /* P7PIN        */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           B7:1;           /*    Bit 7     */
                          _u8           B6:1;           /*    Bit 6     */
                          _u8           B5:1;           /*    Bit 5     */
                          _u8           B4:1;           /*    Bit 4     */
                          _u8           B3:1;           /*    Bit 3     */
                          _u8           B2:1;           /*    Bit 2     */
                          _u8           B1:1;           /*    Bit 1     */
                          _u8           B0:1;           /*    Bit 0     */
                          }      BIT;                   /*              */
                   }            PIN;                    /*              */
};                                                      /*              */
struct st_bsc {                                         /* struct BSC   */
              union {                                   /* BCR          */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           ICIS1 :1;      /*    ICIS1     */
                           _u8           ICIS0 :1;      /*    ICIS0     */
                           _u8           BRSTRM:1;      /*    BRSTRM    */
                           _u8           BRSTS1:1;      /*    BRSTS1    */
                           _u8           BRSTS0:1;      /*    BRSTS0    */
                           _u8                 :1;      /*              */
                           _u8           IOS   :2;      /*    IOS       */
                           }     BIT;                   /*              */
                    }           BCR;                    /*              */
              union {                                   /* WSCR         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           RAMS:1;        /*    RAMS      */
                           _u8           RAM0:1;        /*    RAM0      */
                           _u8           ABW :1;        /*    ABW       */
                           _u8           AST :1;        /*    AST       */
                           _u8           WMS :2;        /*    WMS       */
                           _u8           WC  :2;        /*    WC        */
                           }     BIT;                   /*              */
                    }           WSCR;                   /*              */
};                                                      /*              */
struct st_tmr {                                         /* struct TMR   */
              union {                                   /* TCR0         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           CMIEB:1;       /*    CMIEB     */
                           _u8           CMIEA:1;       /*    CMIEA     */
                           _u8           OVIE :1;       /*    OVIE      */
                           _u8           CCLR :2;       /*    CCLR      */
                           _u8           CKS  :3;       /*    CKS       */
                           }      BIT;                  /*              */
                    }           TCR0;                   /*              */
              union {                                   /* TCR1         */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           CMIEB:1;       /*    CMIEB     */
                           _u8           CMIEA:1;       /*    CMIEA     */
                           _u8           OVIE :1;       /*    OVIE      */
                           _u8           CCLR :2;       /*    CCLR      */
                           _u8           CKS  :3;       /*    CKS       */
                           }      BIT;                  /*              */
                    }           TCR1;                   /*              */
              union {                                   /* TCSR0        */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           CMFB:1;        /*    CMFB      */
                           _u8           CMFA:1;        /*    CMFA      */
                           _u8           OVF :1;        /*    OVF       */
                           _u8           ADTE:1;        /*    ADTE      */
                           _u8           OS  :4;        /*    OS        */
                           }      BIT;                  /*              */
                    }           TCSR0;                  /*              */
              union {                                   /* TCSR1        */
                    _u8           BYTE;                 /*  Byte Access */
                    struct {                            /*  Bit  Access */
                           _u8           CMFB:1;        /*    CMFB      */
                           _u8           CMFA:1;        /*    CMFA      */
                           _u8           OVF :1;        /*    OVF       */
                           _u8               :1;        /*              */
                           _u8           OS  :4;        /*    OS        */
                           }      BIT;                  /*              */
                    }           TCSR1;                  /*              */
              _u16              TCORA;                  /* TCORA        */
              _u16              TCORB;                  /* TCORB        */
              _u16              TCNT;                   /* TCNT         */
};                                                      /*              */
struct st_tmr0 {                                        /* struct TMR0  */
               union {                                  /* TCR          */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           CMIEB:1;      /*    CMIEB     */
                            _u8           CMIEA:1;      /*    CMIEA     */
                            _u8           OVIE :1;      /*    OVIE      */
                            _u8           CCLR :2;      /*    CCLR      */
                            _u8           CKS  :3;      /*    CKS       */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               _s8              wk1;                    /*              */
               union {                                  /* TCSR         */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           CMFB:1;       /*    CMFB      */
                            _u8           CMFA:1;       /*    CMFA      */
                            _u8           OVF :1;       /*    OVF       */
                            _u8           ADTE:1;       /*    ADTE      */
                            _u8           OS  :4;       /*    OS        */
                            }      BIT;                 /*              */
                     }          TCSR;                   /*              */
               _s8              wk2;                    /*              */
               _u8              TCORA;                  /* TCORA        */
               _s8              wk3;                    /*              */
               _u8              TCORB;                  /* TCORB        */
               _s8              wk4;                    /*              */
               _u8              TCNT;                   /* TCNT         */
};                                                      /*              */
struct st_tmr1 {                                        /* struct TMR1  */
               union {                                  /* TCR          */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           CMIEB:1;      /*    CMIEB     */
                            _u8           CMIEA:1;      /*    CMIEA     */
                            _u8           OVIE :1;      /*    OVIE      */
                            _u8           CCLR :2;      /*    CCLR      */
                            _u8           CKS  :3;      /*    CKS       */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               _s8              wk1;                    /*              */
               union {                                  /* TCSR         */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           CMFB:1;       /*    CMFB      */
                            _u8           CMFA:1;       /*    CMFA      */
                            _u8           OVF :1;       /*    OVF       */
                            _u8               :1;       /*              */
                            _u8           OS  :4;       /*    OS        */
                            }      BIT;                 /*              */
                     }          TCSR;                   /*              */
               _s8              wk2;                    /*              */
               _u8              TCORA;                  /* TCORA        */
               _s8              wk3;                    /*              */
               _u8              TCORB;                  /* TCORB        */
               _s8              wk4;                    /*              */
               _u8              TCNT;                   /* TCNT         */
};                                                      /*              */
struct st_tmrx {                                        /* struct TMRX  */
               union {                                  /* TCR          */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           CMIEB:1;      /*    CMIEB     */
                            _u8           CMIEA:1;      /*    CMIEA     */
                            _u8           OVIE :1;      /*    OVIE      */
                            _u8           CCLR :2;      /*    CCLR      */
                            _u8           CKS  :3;      /*    CKS       */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               union {                                  /* TCSR         */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           CMFB:1;       /*    CMFB      */
                            _u8           CMFA:1;       /*    CMFA      */
                            _u8           OVF :1;       /*    OVF       */
                            _u8           ICF :1;       /*    ICF       */
                            _u8           OS  :4;       /*    OS        */
                            }      BIT;                 /*              */
                     }          TCSR;                   /*              */
               _u8              TICRR;                  /* TICRR        */
               _u8              TICRF;                  /* TICRF        */
               _u8              TCNT;                   /* TCNT         */
               _u8              TCORC;                  /* TCORC        */
               _u8              TCORA;                  /* TCORA        */
               _u8              TCORB;                  /* TCORB        */
};                                                      /*              */
struct st_tmry {                                        /* struct TMRY  */
               union {                                  /* TCR          */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           CMIEB:1;      /*    CMIEB     */
                            _u8           CMIEA:1;      /*    CMIEA     */
                            _u8           OVIE :1;      /*    OVIE      */
                            _u8           CCLR :2;      /*    CCLR      */
                            _u8           CKS  :3;      /*    CKS       */
                            }      BIT;                 /*              */
                     }          TCR;                    /*              */
               union {                                  /* TCSR         */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8           CMFB:1;       /*    CMFB      */
                            _u8           CMFA:1;       /*    CMFA      */
                            _u8           OVF :1;       /*    OVF       */
                            _u8           ICIE:1;       /*    ICIE      */
                            _u8           OS  :4;       /*    OS        */
                            }      BIT;                 /*              */
                     }          TCSR;                   /*              */
               _u8              TCORA;                  /* TCORA        */
               _u8              TCORB;                  /* TCORB        */
               _u8              TCNT;                   /* TCNT         */
               union {                                  /* TISR         */
                     _u8           BYTE;                /*  Byte Access */
                     struct {                           /*  Bit  Access */
                            _u8             :7;         /*              */
                            _u8           IS:1;         /*    IS        */
                            }      BIT;                 /*              */
                     }          TISR;                   /*              */
};                                                      /*              */
struct st_ad {                                          /* struct A/D   */
             _u16               ADDRA;                  /* ADDRA        */
             _u16               ADDRB;                  /* ADDRB        */
             _u16               ADDRC;                  /* ADDRC        */
             _u16               ADDRD;                  /* ADDRD        */
             union {                                    /* ADCSR        */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           ADF :1;         /*    ADF       */
                          _u8           ADIE:1;         /*    ADIE      */
                          _u8           ADST:1;         /*    ADST      */
                          _u8           SCAN:1;         /*    SCAN      */
                          _u8           CKS :1;         /*    CKS       */
                          _u8           CH  :3;         /*    CH        */
                          }      BIT;                   /*              */
                   }            ADCSR;                  /*              */
             union {                                    /* ADCR         */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           TRGS:2;         /*    TRGS      */
                          }      BIT;                   /*              */
                   }            ADCR;                   /*              */
};                                                      /*              */
struct st_tc {                                          /* struct TC    */
             union {                                    /* TCONRI       */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           SIMOD:2;        /*    SIMOD     */
                          _u8           SCONE:1;        /*    SCONE     */
                          _u8           ICST :1;        /*    ICST      */
                          _u8           HFINV:1;        /*    HFINV     */
                          _u8           VFINV:1;        /*    VFINV     */
                          _u8           HIINV:1;        /*    HIINV     */
                          _u8           VIINV:1;        /*    VIINV     */
                          }      BIT;                   /*              */
                   }            TCONRI;                 /*              */
             union {                                    /* TCONRO       */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           HOE   :1;       /*    HOE       */
                          _u8           VOE   :1;       /*    VOE       */
                          _u8           CLOE  :1;       /*    CLOE      */
                          _u8           CBOE  :1;       /*    CBOE      */
                          _u8           HOINV :1;       /*    HOINV     */
                          _u8           VOINV :1;       /*    VOINV     */
                          _u8           CLOINV:1;       /*    CLOINV    */
                          _u8           CBOINV:1;       /*    CBOINV    */
                          }      BIT;                   /*              */
                   }            TCONRO;                 /*              */
             union {                                    /* TCONRS       */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           TMRXY :1;       /*    TMRXY     */
                          _u8           ISGENE:1;       /*    ISGENE    */
                          _u8           HOMOD :2;       /*    HOMOD     */
                          _u8           VOMOD :2;       /*    VOMOD     */
                          _u8           CLMOD :2;       /*    CLMOD     */
                          }      BIT;                   /*              */
                   }            TCONRS;                 /*              */
             union {                                    /* SEDGR        */
                   _u8           BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          _u8           VEDG :1;        /*    VEDG      */
                          _u8           HEDG :1;        /*    HEDG      */
                          _u8           CEDG :1;        /*    CEDG      */
                          _u8           HFEDG:1;        /*    HFEDG     */
                          _u8           VFEDG:1;        /*    VFEDG     */
                          _u8           PREQF:1;        /*    PREQF     */
                          _u8           IHI  :1;        /*    IHI       */
                          _u8           IVI  :1;        /*    IVI       */
                          }      BIT;                   /*              */
                   }            SEDGR;                  /*              */
};                                                      /*              */
#define KBCOMP  (*(volatile union  un_kbcomp*)0xFFFEE4) /* KBCOMPAddress*/
#define IIC0    (*(volatile struct st_iic   *)0xFFFFD8) /* IIC0  Address*/
#define IIC1    (*(volatile struct st_iic   *)0xFFFF88) /* IIC1  Address*/
#define ICDR    EQU.ICE1.UN_ICDR                        /* ICDR  Change */
#define ICMR    EQU.ICE1.UN_ICMR                        /* ICDR  Change */
#define SAR     EQU.ICE0.UN_SAR                         /* SAR   Change */
#define SARX    EQU.ICE0.UN_SARX                        /* SARX  Change */
#define DDCSWR  (*(volatile union  un_ddcswr*)0xFFFEE6) /* DDCSWRAddress*/
#define INTC    (*(volatile struct st_intc  *)0xFFFEE8) /* INTC  Address*/
#define DTC     (*(volatile struct st_dtc   *)0xFFFEEE) /* DTC   Address*/
#define FLASH   (*(volatile struct st_flash *)0xFFFF80) /* FLASH Address*/
#define PWM     (*(volatile struct st_pwm   *)0xFFFF82) /* PWM   Address*/
#define SBYCR   (*(volatile union  un_sbycr *)0xFFFF84) /* SBYCR Address*/
#define LPWRCR  (*(volatile union  un_lpwrcr*)0xFFFF85) /* LPWRCRAddress*/
#define MSTPCR  (*(volatile union  un_mstpcr*)0xFFFF86) /* MSTPCRAddress*/
#define STCR    (*(volatile union  un_stcr  *)0xFFFFC3) /* STCR  Address*/
#define SYSCR   (*(volatile union  un_syscr *)0xFFFFC4) /* SYSCR Address*/
#define MDCR    (*(volatile union  un_mdcr  *)0xFFFFC5) /* MDCR  Address*/
#define SCI0    (*(volatile struct st_sci   *)0xFFFFD8) /* SCI0  Address*/
#define SCI1    (*(volatile struct st_sci   *)0xFFFF88) /* SCI1  Address*/
#define FRT     (*(volatile struct st_frt   *)0xFFFF90) /* FRT   Address*/
#define OCRB    OCRA                                    /* OCRB  Change */
#define OCRAR   ICRA                                    /* OCRAR Change */
#define OCRAF   ICRB                                    /* OCRAF Change */
#define OCRDM   ICRC                                    /* OCRDM Change */
#define PWMX    (*(volatile union  un_pwmx  *)0xFFFFA0) /* PWMX  Address*/
#define DACR    REGS1.ST_DACR                           /* DACR  Change */
#define DACNT   REGS1.ST_DACNT                          /* DACNT Change */
#define DADRA   REGS0.ST_DADRA                          /* DADRA Change */
#define DADRB   REGS0.ST_DADRB                          /* DADRB Change */
#define WDT0    (*(volatile union  un_wdt0  *)0xFFFFA8) /* WDT0  Address*/
#define WDT1    (*(volatile union  un_wdt1  *)0xFFFFEA) /* WDT1  Address*/
#define P1      (*(volatile struct st_p1    *)0xFFFFAC) /* P1    Address*/
#define P2      (*(volatile struct st_p2    *)0xFFFFAD) /* P2    Address*/
#define P3      (*(volatile struct st_p3    *)0xFFFFAE) /* P3    Address*/
#define P4      (*(volatile struct st_p4    *)0xFFFFB5) /* P4    Address*/
#define P5      (*(volatile struct st_p5    *)0xFFFFB8) /* P5    Address*/
#define P6      (*(volatile struct st_p6    *)0xFFFFB9) /* P6    Address*/
#define P7      (*(volatile struct st_p7    *)0xFFFFBE) /* P7    Address*/
#define BSC     (*(volatile struct st_bsc   *)0xFFFFC6) /* BSC   Address*/
#define TMR     (*(volatile struct st_tmr   *)0xFFFFC8) /* TMR   Address*/
#define TMR0    (*(volatile struct st_tmr0  *)0xFFFFC8) /* TMR0  Address*/
#define TMR1    (*(volatile struct st_tmr1  *)0xFFFFC9) /* TMR1  Address*/
#define TMRX    (*(volatile struct st_tmrx  *)0xFFFFF0) /* TMRX  Address*/
#define TMRY    (*(volatile struct st_tmry  *)0xFFFFF0) /* TMRY  Address*/
#define AD      (*(volatile struct st_ad    *)0xFFFFE0) /* A/D   Address*/
#define TC      (*(volatile struct st_tc    *)0xFFFFFC) /* TC    Address*/

#define ASM(x)  asm volatile(x)
#define EI      ASM("andc.b #0x7f,ccr")
#define EUI     ASM("andc.b #0x3f,ccr")
#define DUI     ASM("orc.b #0xC0,ccr")
#define DI      ASM("orc.b #0x80,ccr")
#define sleep   ASM("sleep")

#endif /* _H8S_2128S_H_ */
