#ifndef	_H8S_2144S_INC_
#define	_H8S_2144S_INC_	1

#define SBYCR   0xFF84
#define LPWRCR  0xFF85

#define MSTPCR  0xFF86
#define MSTPCRH MSTPCR
#define MSTPCRL 0xFF87

#define STCR    0xFFC3
#define SYSCR   0xFFC4
#define MDCR    0xFFC5
#define BCR     0xFFC6
#define WSCR    0xFFC7

#define INTC    0xFEE8
#define SYSCR   0xFFC4
#define ISCR    0xFEEC
#define ISCRH   ISCR
#define ISCRL   0xFEED
#define IER     0xFFC2
#define ISR     0xFEEB
#define KMIMR   0xFFF1
#define KMIMRA  0xFFF3
#define ICRA    INTC
#define ICRB    0xFEE9
#define ICRC    0xFEEA
#define ABRKCR  0xFEF4
#define BAR     0xFEF5
#define BARA    BAR
#define BARB    0xFEF6
#define BARC    0xFEF7

#define FLASH   0xFF80
#define FLMCR1  FLASH
#define FLMCR2  0xFF81
#define EBR1    0xFF82
#define EBR2    0xFF83
#define STCR    0xFFC3

#define WDT0    0xFFA8
#define WDTCSR0 WDT0
#define WDTCNT0 0xFFA9
#define WDT1    0xFFEA
#define WDTCSR1 WDT1
#define WDTCNT1 0xFFEB

#define P1PCR   0xFFAC
#define P1DDR   0xFFB0
#define P1DR    0xFFB2
#define P2PCR   0xFFAD
#define P2DDR   0xFFB1
#define P2DR    0xFFB3
#define P3PCR   0xFFAE
#define P3DDR   0xFFB4
#define P3DR    0xFFB6
#define P4DDR   0xFFB5
#define P4DR    0xFFB7
#define P5DDR   0xFFB8
#define P5DR    0xFFBA
#define KMPCR   0xFFF2
#define P6DDR   0xFFB9
#define P6DR    0xFFBB
#define P7PIN   0xFFBE
#define P8DDR   0xFFBD
#define P8DR    0xFFBF
#define P9DDR   0xFFC0
#define P9DR    0xFFC1
#define PADDR   0xFFAB
#define PADR    0xFFAA
#define PAPIN   PADDR
#define PBDDR   P7PIN
#define PBODR   0xFFBC
#define PBPIN   P8DDR

#define SCI0    0xFFD8
#define SMR0    SCI0
#define BRR0    0xFFD9
#define SCR0    0xFFDA
#define TDR0    0xFFDB
#define SSR0    0xFFDC
#define RDR0    0xFFDD
#define SCMR0   0xFFDE

#define SCI1    0xFF88
#define SMR1    SCI1
#define BRR1    0xFF89
#define SCR1    0xFF8A
#define TDR1    0xFF8B
#define SSR1    0xFF8C
#define RDR1    0xFF8D
#define SCMR1   0xFF8E

#define SCI2    0xFFA0
#define SMR2    SCI2
#define BRR2    0xFFA1
#define SCR2    0xFFA2
#define TDR2    0xFFA3
#define SSR2    0xFFA4
#define RDR2    0xFFA5
#define SCMR2   0xFFA6
#define KBCOMP  0xFEE4

#define FRT     0xFF90
#define TIER    FRT
#define TCSR    0xFF91
#define FRC     0xFF92
#define OCRA    0xFF94
#define OCRB    OCRA
#define TCR     0xFF96
#define TOCR    0xFF97
#define ICRAH   0xFF98
#define ICRAL   0xFF99
#define ICRBH   0xFF9A
#define ICRBL   0xFF9B
#define ICRCH   0xFF9C
#define ICRCL   0xFF9D
#define ICRDH   0xFF9E
#define ICRDL   0xFF9F
#define OCRAR   ICRA
#define OCRAF   ICRB
#define OCRDM   ICRC

#define PWMX    0xFFA0
#define DACRX   PWMX
#define DACNT   0xFFA6
#define DACNTH  DACNT
#define DACNTL  0xFFA7
#define DADRA   0xFFA0
#define DADRAH  DADRA
#define DADRAL  0xFFA1
#define DADRB   DACNT
#define DADRBH  DADRB
#define DADRBL  0xFFA7

#define TMR8B   0xFFC8
#define TMR0    0xFFC8
#define TCR0    TMR0
#define TCSR0   0xFFCA
#define TCORA0  0xFFCC
#define TCORB0  0xFFCE
#define TCNT0   0xFFD0
#define TMR1    0xFFC9
#define TCR1    TMR1
#define TCSR1   0xFFCB
#define TCORA1  0xFFCD
#define TCORB1  0xFFCF
#define TCNT1   0xFFD1
#define TMRY    0xFFF0
#define TCRY    TMRY
#define TCSRY   0xFFF1
#define TCORAY  0xFFF2
#define TCORBY  0xFFF3
#define TCNTY   0xFFF4
#define TISR    0xFFF5

#define AD      0xFFE0
#define ADDRAH  AD
#define ADDRAL  0xFFE1
#define ADDRBH  0xFFE2
#define ADDRBL  0xFFE3
#define ADDRCH  0xFFE4
#define ADDRCL  0xFFE5
#define ADDRDH  0xFFE6
#define ADDRDL  0xFFE7
#define ADCSR   0xFFE8
#define ADCR    0xFFE9

#define DA      0xFFF8
#define DADR0   DA
#define DADR1   0xFFF9
#define DACR    0xFFFA

#endif	/* _H8S_2144S_INC_ */
