#ifndef	_H8S_COMMON0_INC_
#define	_H8S_COMMON0_INC_ 1

#ifndef _H8S_MPU_
#warn "undefined _H8S_MPU_."
#else
# if _H8S_MPU_==2128
#	include "2128s.inc"
# else
#  if _H8S_MPU_==2144
#	include "2144s.inc"
#  else
#error "_H8S_MPU_ is invalid MPU model number."
#  endif
# endif
#endif

#if	(SCIch == 0)
#define _sci_nbuf	_sci0_nbuf
#define _sci_getc	_sci0_getc
#define _sci_putc	_sci0_putc
#define _sci_puts	_sci0_puts
#else
#	if	(SCIch == 1)
#define _sci_nbuf	_sci1_nbuf
#define _sci_getc	_sci1_getc
#define _sci_putc	_sci1_putc
#define _sci_puts	_sci1_puts
#	endif
#endif

.macro	VAR	lbl
.global	\lbl
\lbl:
.endm

.macro	BEGIN	lbl
.global	\lbl
.func	\lbl
\lbl:
.endm

.macro	RETURN
	rts
.endfunc
.endm

.macro	ENDFN
.endfunc
.endm

.macro	EI
	andc.b	#0x7f, ccr
.endm

.macro	EUI
	andc.b	#0x3f, ccr
.endm

.macro	DUI
	orc.b	#0xC0, ccr
.endm

.macro	DI
	orc.b	#0x80, ccr
.endm

.macro	SWAP_NIBBLE_B	reg=r0l
	rotl.b	#2, \reg
	rotl.b	#2, \reg
.endm

.macro	LOCK_SHARE_NOWAIT_RETURN	sem=_sys_MPX_CTRL, reg=ER1
	mov.l	#\sem, \reg
	tas 	@\reg
	beq 	199f
	rts
199:
.endm

.macro	LOCK_SHARE	sem=_sys_MPX_CTRL, reg=ER1
	mov.l	#\sem, \reg
199:
	tas 	@\reg
	bne 	199b
.endm

.macro	FREE_SHARE	sem=_sys_MPX_CTRL, reg=ER1
	mov.l	#\sem, \reg
	bclr	#7:3, @\reg
.endm

		.h8300s

#include "SYS_default.inc"

#define	SYS_WAIT_LOOP_CNT_us(x)	(( ( ((_CPUCLOCK_)*(x)) / (100000ULL*3ULL) ) +5ULL)/10ULL)
.macro	SYS_WAIT_LOOP_us	cnt=100ULL, reg=ER1
	mov.l	#SYS_WAIT_LOOP_CNT_us(\cnt), \reg
1:
	dec.l	#1, \reg	; 1
	bne 	1b:8		; 2
.endm

#endif	/* _H8S_COMMON0_INC_ */
