  /*
*//* 
*//* H8S GPS monitor
*//*  10main.c: applications and mini-monitor shell kick starter.
*//*     Copyright (C) 2011 by HI.
*//*
*/

#include "H8S_common0.h"
#include "basicIO.h"

#define CRLF "\r\n"

struct timeval_t {
	LONG	sec;
	LONG	subsec;
} __attribute__ ((packed));
struct tm_t {
	WORD	YYYY; // BASEYYYY-(BASEYYYY+135)
	BYTE	MM; // 01-12
	BYTE	DD; // 01-28,29,30,31
	BYTE	hh; // 00-23
	BYTE	mm; // 00-59
	BYTE	ss; // 00-60
} __attribute__ ((packed));

static struct timeval_t x;
static struct tm_t t;

static const char *weekname[]={
	"Sun","Mon","Tue","Wed","Thu","Fri","Sat","Sun"
};

void print_time(void){
	sys_time_gettime(&x);
#if 0
	printLONG(x.sec);printSP();printLONG(x.subsec);printSP();
	printLONG(timeutl_tv2tm(&t,&x));printSP();
	printBYTE(t.hh);sci_putc(':');printBYTE(t.mm);sci_putc(':');printBYTE(t.ss);printSP();
	printBYTE(timeutl_day_of_week(&t));printSP();
#else
	timeutl_tv2tm(&t,&x);
	printf(CRLF"%d = %04d-%2d-%2d %02d:%02d:%02d(%s)",x.sec,t.YYYY,t.MM,t.DD,t.hh,t.mm,t.ss,weekname[timeutl_day_of_week(&t)]);
#endif
}

void lcd_putc(BYTE c){
	CLCD_dat(c);
	sys_wait_20us();
}
void displaySP(void){
	lcd_putc(' ');
}
void displayCRLF(void){
	CLCD_cmd(0xc0);
	sys_wait_20us();
}
BYTE displayNIBL(BYTE x){
	lcd_putc(chr2hex(x));
	return(x);
}
BYTE displayBYTE(BYTE x){
	displayNIBL(x>>4);
	displayNIBL(x);
	return(x);
}
WORD displayWORD(WORD x){
	displayBYTE(x >> 8);
	displayBYTE(x & 0xff);
	return(x);
}
LONG displayLONG(LONG x){
	displayWORD(x >> 16);
	displayWORD(x & 0xffff);
	return(x);
}
void display_time(void){
	sys_time_gettime(&x);
	displayCRLF();
#if 0
	displayWORD(timeutl_tv2tm(&t,&x));displaySP();
	displayBYTE(t.hh);lcd_putc(':');displayBYTE(t.mm);lcd_putc(':');displayBYTE(t.ss);displaySP();
#else
	timeutl_tv2tm(&t,&x);
	CLCD_printf("%2d-%2d %02d:%02d:%02d",t.MM,t.DD,t.hh,t.mm,t.ss);
#endif
}
#if 0
void FRT_init(void){
	MSTPCR.BIT._FRT= 0;     // lets begin use the free running timer function
	FRT.TCR.BYTE= 0x00;     // initialize FRT control (set freq. SYSCLK/2)
	FRT.TIER.BYTE= 0x01;    // initialize FRT interruption control
	FRT.TOCR.BYTE= 0x40;    // initialize FRT TOCCR l (set OutputEnable OCA)
	FRT.OCRA= 0x0002;       // initialize FRT OCR (set 1/2)
	FRT.FRC=  0x0002;       // initialize FRT OCR (set 1/2)

	FRT.TCSR.BYTE&= 0;      // initialize FRT TCSR
	FRT.TCSR.BIT.CCLRA=1;   // set TCSR(clear FRC at OCA)
}
#endif
#pragma interrupt
void NMI_hook(void){
	__asm__ volatile("bnot.b #7:3,@0xb7:8");
}
void main_init(void){
	CLCD_init();
#if 0
	sys_time_settick_val(28140884);
	sys_time_settick_adj(86);
#endif
	t.YYYY=2011;
	t.MM=12;
	t.DD=12;
	t.hh=22;
	t.mm=26;
	t.ss=0;
	timeutl_tm2tv(&t,&x);
	sys_time_settime(&x);
	sys_wait_1ms();
	CLCD_puts("app2");
	sys_LED_FLAG = 0x00;
	sys_NMI_hook_ptr= NMI_hook; // P47NMIȿž٤ǽ
	P4.DDR= sys_PIO_DDR_P4= (sys_PIO_DDR_P4 | 0xc0); // P47output.P46SYSCLKoutˤ
//	FRT_init();
}

static void printMEM(void *x){
BYTE c;
	c= *(BYTE *)x;
	printBYTE( c );
}

void dump_mem(void *x){
LONG	i;
	for(i=0;i<256;i++){
		if(0 == (i & 0x0f)){
			printCRLF();
			printLONG((i+(LONG)x));
			sci_puts(": ");
		};
		printMEM((void *)(i+(LONG)x));
		if(0 != (i & 0x01)){
			sci_puts(" ");
		};
	};
	printCRLF();
}

void dump_mem16(BYTE *s,void *x){
LONG	i;
	sci_puts(s);
	printLONG((LONG)x);
	sci_puts(": ");
	for(i=0;i<16;i++){
		printMEM((void *)(i+(LONG)x));
		if(0 != (i & 0x01)){
			sci_puts(" ");
		};
	};
	printCRLF();
}

void main_loop(void){
	dump_mem((void *)0xfffe080);
	display_time();
	sleep;
	switch(0x33 & BTNLED()){
	  case(0x11):
		sci_putc('_');
		sys_LED_FLAG ^= 0x08;
		CLCD_cmd(0x01);
		sys_wait_10ms();
		CLCD_puts("0x11");
		break;;
	  case(0x22):
		sci_putc('~');
		sys_LED_FLAG ^= 0x04;
		CLCD_cmd(0x01);
		sys_wait_10ms();
		CLCD_puts("0x22");
		break;;
	  case(0x13):
	  case(0x23):
	  case(0x33):
		printCRLF();
		print_time();
		break;;
	  default:
		break;;
	};
}

extern void NMEA_TSIP_monitor(void);

int main(){
	main_init();
	NMEA_TSIP_monitor(); // no return;
	while(0==sci_nbuf()){	// SCIϤޤǥ롼
		main_loop();
	};
	abort();;
	return(0);	// ꥻå㳰äƥ˥
}
